/* float.h */
#ifndef _FLOAT_H___
#define _FLOAT_H___
/* Produced by enquire version 4.3, CWI, Amsterdam */

   /* Radix of exponent representation */
#undef FLT_RADIX
#define FLT_RADIX 2
   /* Number of base-FLT_RADIX digits in the significand of a float */
#undef FLT_MANT_DIG
#define FLT_MANT_DIG 24
   /* Number of decimal digits of precision in a float */
#undef FLT_DIG
#define FLT_DIG 6
   /* Addition rounds to 0: zero, 1: nearest, 2: +inf, 3: -inf, -1: unknown */
#undef FLT_ROUNDS
#define FLT_ROUNDS 1
   /* Difference between 1.0 and the minimum float greater than 1.0 */
#undef FLT_EPSILON
#define FLT_EPSILON 1.19209290e-07F
   /* Minimum int x such that FLT_RADIX**(x-1) is a normalised float */
#undef FLT_MIN_EXP
#define FLT_MIN_EXP (-125)
   /* Minimum normalised float */
#undef FLT_MIN
#define FLT_MIN 1.17549435e-38F
   /* Minimum int x such that 10**x is a normalised float */
#undef FLT_MIN_10_EXP
#define FLT_MIN_10_EXP (-37)
   /* Maximum int x such that FLT_RADIX**(x-1) is a representable float */
#undef FLT_MAX_EXP
#define FLT_MAX_EXP 128
   /* Maximum float */
#undef FLT_MAX
#define FLT_MAX 3.40282347e+38F
   /* Maximum int x such that 10**x is a representable float */
#undef FLT_MAX_10_EXP
#define FLT_MAX_10_EXP 38

   /* Number of base-FLT_RADIX digits in the significand of a double */
#undef DBL_MANT_DIG
#define DBL_MANT_DIG 53
   /* Number of decimal digits of precision in a double */
#undef DBL_DIG
#define DBL_DIG 15
   /* Difference between 1.0 and the minimum double greater than 1.0 */
#undef DBL_EPSILON
#define DBL_EPSILON 2.2204460492503131e-16

/* *** WARNING: Possibly bad output from printf above */
/*     expected value around 2.2204460492503131e-16, bit pattern:
    00111100 10110000 00000000 00000000 00000000 00000000 00000000 00000000 */
/*     sscanf gave           2.2204460492503126e-16, bit pattern:
    00111100 10101111 11111111 11111111 11111111 11111111 11111111 11111110 */
/*     difference= 4.9303806576313232e-32 */

   /* Minimum int x such that FLT_RADIX**(x-1) is a normalised double */
#undef DBL_MIN_EXP
#define DBL_MIN_EXP (-1021)
   /* Minimum normalised double */
#undef DBL_MIN
#define DBL_MIN 2.2250738585072010e-308

/* *** WARNING: Possibly bad output from printf above */
/*     expected value around 2.2250738585072010e-308, bit pattern:
    00000000 00010000 00000000 00000000 00000000 00000000 00000000 00000000 */
/*     sscanf gave           2.2250738585071970e-308, bit pattern:
    00000000 00001111 11111111 11111111 11111111 11111111 11111111 11111000 */
/*     difference= 3.9525251667299726e-323 */

   /* Minimum int x such that 10**x is a normalised double */
#undef DBL_MIN_10_EXP
#define DBL_MIN_10_EXP (-307)
   /* Maximum int x such that FLT_RADIX**(x-1) is a representable double */
#undef DBL_MAX_EXP
#define DBL_MAX_EXP 1024
   /* Maximum double */
#undef DBL_MAX
#define DBL_MAX 1.7976931348623168e+308

/* *** WARNING: Possibly bad output from printf above */
/*     expected value around 1.7976931348623165e308, bit pattern:
    01111111 11101111 11111111 11111111 11111111 11111111 11111111 11111111 */
/*     sscanf gave           NaN, bit pattern:
    01111111 11110000 00000000 00000000 00000000 00000000 00000000 00000101 */
/*     difference= NaN */

   /* Maximum int x such that 10**x is a representable double */
#undef DBL_MAX_10_EXP
#define DBL_MAX_10_EXP 308

   /* Number of base-FLT_RADIX digits in the significand of a long double */
#undef LDBL_MANT_DIG
#define LDBL_MANT_DIG 53
   /* Number of decimal digits of precision in a long double */
#undef LDBL_DIG
#define LDBL_DIG 15
   /* Difference between 1.0 and the minimum long double greater than 1.0 */
#undef LDBL_EPSILON
#define LDBL_EPSILON 2.2204460492503131e-16L

/* *** WARNING: Possibly bad output from printf above */
/*     expected value around 2.2204460492503131e-16, bit pattern:
    00111100 10110000 00000000 00000000 00000000 00000000 00000000 00000000 */
/*     sscanf gave           2.2204460492503126e-16, bit pattern:
    00111100 10101111 11111111 11111111 11111111 11111111 11111111 11111110 */
/*     difference= 4.9303806576313232e-32 */

   /* Minimum int x such that FLT_RADIX**(x-1) is a normalised long double */
#undef LDBL_MIN_EXP
#define LDBL_MIN_EXP (-1021)
   /* Minimum normalised long double */
#undef LDBL_MIN
#define LDBL_MIN 2.2250738585072010e-308L

/* *** WARNING: Possibly bad output from printf above */
/*     expected value around 2.2250738585072010e-308, bit pattern:
    00000000 00010000 00000000 00000000 00000000 00000000 00000000 00000000 */
/*     sscanf gave           2.2250738585071970e-308, bit pattern:
    00000000 00001111 11111111 11111111 11111111 11111111 11111111 11111000 */
/*     difference= 3.9525251667299726e-323 */

   /* Minimum int x such that 10**x is a normalised long double */
#undef LDBL_MIN_10_EXP
#define LDBL_MIN_10_EXP (-307)
   /* Maximum int x such that FLT_RADIX**(x-1) is a representable long double */
#undef LDBL_MAX_EXP
#define LDBL_MAX_EXP 1024
   /* Maximum long double */
#undef LDBL_MAX
#define LDBL_MAX 1.7976931348623168e+308L

/* *** WARNING: Possibly bad output from printf above */
/*     expected value around 1.7976931348623165e308, bit pattern:
    01111111 11101111 11111111 11111111 11111111 11111111 11111111 11111111 */
/*     sscanf gave           NaN, bit pattern:
    01111111 11110000 00000000 00000000 00000000 00000000 00000000 00000101 */
/*     difference= NaN */

   /* Maximum int x such that 10**x is a representable long double */
#undef LDBL_MAX_10_EXP
#define LDBL_MAX_10_EXP 308

#endif /*  _FLOAT_H___ */

/* For hints on dealing with the 6 problems above
   see the section 'TROUBLESHOOTING' in the file ./enquire.c */
